<template>
  <section class="relative">
    <PluginDatePicker
      ref="calendarInstance"
      v-model.range="currentRange"
      :locale="{ id: 'ru', masks: { weekdays: 'WW' } }"
      :attributes="highlightAttributes"
      :disabled-dates="disabledDates"
      :min-date="new Date()"
      mode="date"
      color="teal"
      class="w-full"
      :select-attribute="{
        highlight: {
          start: { contentStyle: { color: 'white' } },
          end: { contentStyle: { color: 'white' } },
        },
      }"
      @did-move="onPageChange"
    />

    <v-overlay
      v-if="isLoading"
      :model-value="true"
      scrim="white"
      contained
      persistent
      class="flex items-center justify-center"
    >
      <v-progress-circular
        color="var(--tw-color-teal-600)"
        size="64"
        indeterminate
      />
    </v-overlay>
  </section>

  <section class="grid grid-cols-12 gap-2 mt-4">
    <v-sheet class="flex items-center justify-start md:justify-center col-span-12 md:col-span-4 text-left md:text-center p-3 rounded bg-gray-100">
      <v-scroll-y-transition leave-absolute>
        <span
          v-if="!currentRange?.start"
          class="text-gray-600"
        >
          Выберите дату <br>
          &nbsp;
        </span>

        <span v-else>
          {{ dt.display(currentRange.start, 'd MMMM,') }} <br class="hidden md:block">
          {{ dt.display(currentRange.start, 'cccc') }}
        </span>
      </v-scroll-y-transition>
    </v-sheet>

    <v-sheet class="flex flex-col items-center justify-center col-span-12 md:col-span-4 text-center text-gray-500 px-4">
      <section>
        <v-icon icon="mdi-calendar-arrow-right" />
      </section>

      <v-scroll-y-transition>
        <section v-if="currentRange?.start && currentRange?.end">
          {{ bookingNightsCount }} {{ getNightsLabel(bookingNightsCount) }}
        </section>
      </v-scroll-y-transition>
    </v-sheet>

    <v-sheet class="flex items-center justify-start md:justify-center col-span-12 md:col-span-4 text-left md:text-center p-3 rounded bg-gray-100">
      <v-scroll-y-transition leave-absolute>
        <span
          v-if="!currentRange?.end"
          class="text-gray-600"
        >
          Выберите дату <br>
          &nbsp;
        </span>

        <span v-else>
          {{ dt.display(currentRange.end, 'd MMMM,') }} <br class="hidden md:block">
          {{ dt.display(currentRange.end, 'cccc') }}
        </span>
      </v-scroll-y-transition>
    </v-sheet>
  </section>
</template>

<script setup lang="ts">
import { computed, ref, watch } from 'vue';

import { HttpClient } from '@/http';
import { useDateTime } from '@/composables';
import { getNightsCount, getNightsLabel } from '@/utils';

type BookingDatesRange = {
  start: Date | null;
  end: Date | null;
};

type DatesSelectionProps = {
  property: IProperty | null;
  modelValue: BookingDatesRange | null;
};

const props = defineProps<DatesSelectionProps>();
const emit = defineEmits(['update:modelValue']);

const dt = useDateTime();

const calendarInstance = ref<any | null>(null);
const isLoading = ref(false);

const disabledDates = ref<any[]>([]);
const highlightAttributes = ref<any[]>([]);

const currentRange = ref<BookingDatesRange>({
  start: null,
  end: null,
});

const bookingNightsCount = computed(() => {
  const startDate = currentRange.value?.start;
  const endDate = currentRange.value?.end;

  if (!startDate || !endDate) return 0;
  return getNightsCount(startDate, endDate);
});

const resetSelection = () => {
  currentRange.value = { start: null, end: null };
  emit('update:modelValue', null);
};

const onPageChange = async ([page]: any[]) => {
  if (!props.property) return;

  isLoading.value = true;

  const searchStart = dt.origin.local(page.year, page.month, 1).startOf('day');
  const searchEnd = dt.origin.local(page.year, page.month, 1).endOf('month');
  const propertyId = props.property.id;

  const searchRange = {
    start: encodeURIComponent(searchStart.toISO()!),
    end: encodeURIComponent(searchEnd.toISO()!),
  };

  disabledDates.value = [searchRange];

  const { data: { values: bookings } } = await HttpClient.get<IVerboseBooking[]>('/v1/bookings/range', {
    params: { ...searchRange, propertyId },
  });

  disabledDates.value = [];
  highlightAttributes.value = [];

  (bookings ?? []).forEach(booking => {
    const propertyColor = props.property!.color;

    const start = dt.wrap(booking.startDate).toLocal();
    const end = dt.wrap(booking.endDate).toLocal();

    disabledDates.value.push({
      start: start.plus({ days: 1 }).toISO(),
      end: end.minus({ days: 1 }).toISO(),
    });

    highlightAttributes.value.push({
      dates: { start: start.toISO(), end: end.toISO() },
      key: booking.id,
      highlight: {
        start: {
          contentStyle: { color: propertyColor },
          style: { borderColor: propertyColor },
          fillMode: 'outline',
        },
        base: {
          style: { backgroundColor: propertyColor, opacity: 0.6 },
          fillMode: 'light',
        },
        end: {
          contentStyle: { color: propertyColor },
          style: { borderColor: propertyColor },
          fillMode: 'outline',
        },
      },
    });
  });

  isLoading.value = false;
};

watch(() => props.property, () => {
  const currentDate = dt.origin.now();

  calendarInstance.value?.move(currentDate.toISO());
  onPageChange([{ month: currentDate.month, year: currentDate.year }]);

  resetSelection();
});

watch(currentRange, range => {
  const { start, end } = range ?? {};
  if (!start || !end) return;

  const startDate = dt.wrap(start);
  const endDate = dt.wrap(end);

  if (startDate.equals(endDate)) {
    return resetSelection();
  }

  /**
   * Start date begins from 14 hours local time - Default check-in time
   * End date is usually 12 hours local time - Default check-out time
   */
  emit('update:modelValue', {
    start: startDate.startOf('day').plus({ hours: 14 }).toISO(),
    end: endDate.startOf('day').plus({ hours: 12 }).toISO(),
  });
});
</script>